class T extends Thread {
    public static int toFinish;
    public static int x;

    public static void zzz(double sec)
    {
	long z = System.currentTimeMillis() + 
	    (long)(1000.0 * sec * Math.random());
	while (System.currentTimeMillis() < z) { }
    }   

    public void run()
    {
	System.out.println("THREAD STARTED.");
	for (int i = 0; i < 100; i++) {
	    int tmp = x;
	    tmp++;
	    zzz(0.01);
	    x = tmp;
	}
	System.out.println("THREAD STOPPED.");
	toFinish--;
    }

    public static void main(String[] args)
    {
	x = 0;
	toFinish = 0;
	while (toFinish < 3) {
	    T t = new T(); 
	    t.start();
	    toFinish++;
	}

	while (toFinish > 0) {}
	System.out.println("x = " + x);
    }
}
class T0 extends Thread {
    public static int toFinish;
    public static int x;

    public static void zzz(double sec)
    {
	long z = System.currentTimeMillis() + 
	    (long)(1000.0 * sec * Math.random());
	while (System.currentTimeMillis() < z) { }
    }   

    public synchronized void run()
    {
	System.out.println("THREAD STARTED.");
	for (int i = 0; i < 100; i++) {
	    {
		int tmp = x;
		tmp++;
		zzz(0.01);
		x = tmp;
	    }
	}
	System.out.println("THREAD STOPPED.");
	toFinish--;
    }

    public static void main(String[] args)
    {
	x = 0;
	toFinish = 0;
	while (toFinish < 3) {
	    T0 t = new T0(); 
	    t.start();
	    toFinish++;
	}

	while (toFinish > 0) {}
	System.out.println("x = " + x);
    }
}
class T1 extends Thread {
    public static int toFinish;
    public static int x;

    public static void zzz(double sec)
    {
	long z = System.currentTimeMillis() + 
	    (long)(1000.0 * sec * Math.random());
	while (System.currentTimeMillis() < z) { }
    }   

    public void run()
    {
	System.out.println("THREAD STARTED.");
	for (int i = 0; i < 100; i++) {
	    synchronized (this) {
		int tmp = x;
		tmp++;
		zzz(0.01);
		x = tmp;
	    }
	}
	System.out.println("THREAD STOPPED.");
	toFinish--;
    }

    public static void main(String[] args)
    {
	x = 0;
	toFinish = 0;
	while (toFinish < 3) {
	    T1 t = new T1(); 
	    t.start();
	    toFinish++;
	}

	while (toFinish > 0) {}
	System.out.println("x = " + x);
    }
}
class T2 extends Thread {
    public static int toFinish;
    public static int x;
    public static Object globalLock = new Object();

    public static void zzz(double sec)
    {
	long z = System.currentTimeMillis() + 
	    (long)(1000.0 * sec * Math.random());
	while (System.currentTimeMillis() < z) { }
    }   

    public void run()
    {
	System.out.println("THREAD STARTED.");
	for (int i = 0; i < 100; i++) {
	    synchronized (globalLock) {
		int tmp = x;
		tmp++;
		zzz(0.01);
		x = tmp;
	    }
	}
	System.out.println("THREAD STOPPED.");
	toFinish--;
    }

    public static void main(String[] args)
    {
	x = 0;
	toFinish = 0;
	while (toFinish < 3) {
	    T2 t = new T2(); 
	    t.start();
	    toFinish++;
	}

	while (toFinish > 0) {}
	System.out.println("x = " + x);
    }
}
class T3 extends Thread {
    public static int toFinish;
    public static int x;
    public static Object globalLock = new Object();

    public static void zzz(double sec)
    {
	long z = System.currentTimeMillis() + 
	    (long)(1000.0 * sec * Math.random());
	while (System.currentTimeMillis() < z) { }
    }   

    public void run()
    {
	for (int i = 0; i < 100; i++) {
	    synchronized (globalLock) {
		int tmp = x;
		tmp++;
		zzz(0.0001);
		x = tmp;
	    }
	}
	toFinish--;
    }

    public static void main(String[] args)
    {
	for (int i = 1; i < 100; i++) {
	    x = 0;
	    toFinish = 0;
	    while (toFinish < 3) {
		T3 t = new T3(); 
		t.start();
		toFinish++;
	    }
	    
	    while (toFinish > 0) {}
	    System.out.print(".");
	}
	System.out.println("x = " + x);
    }
}
class T4 extends Thread {
    public static int toFinish;
    public static int x;
    public static Object globalLock = new Object();

    public static void zzz(double sec)
    {
	long z = System.currentTimeMillis() + 
	    (long)(1000.0 * sec * Math.random());
	while (System.currentTimeMillis() < z) { }
    }   

    public void run()
    {
	for (int i = 0; i < 100; i++) {
	    synchronized (globalLock) {
		int tmp = x;
		tmp++;
		zzz(0.0001);
		x = tmp;
	    }
	}
	synchronized (globalLock) {toFinish--;}
    }

    public static void main(String[] args)
    {
	for (int j = 1; j < 100; j++) {
	    x = 0;
	    toFinish = 0;
	    while (toFinish < 3) {
		T4 t = new T4(); 
		t.start();
		synchronized (globalLock) {toFinish++;}
	    }
	    
	    while (toFinish > 0) {}
	    System.out.print(".");
	}
	System.out.println("x = " + x);
    }
}
class T5 extends Thread {
    public static int toFinish;
    public static int x;
    public static Object globalLock = new Object();

    public static void zzz(double sec)
    {
	long z = System.currentTimeMillis() + 
	    (long)(1000.0 * sec * Math.random());
	while (System.currentTimeMillis() < z) { }
    }   

    public void run()
    {
	for (int i = 0; i < 100; i++) {
	    synchronized (globalLock) {
		int tmp = x;
		tmp++;
		zzz(0.0001);
		x = tmp;
	    }
	}
	synchronized (globalLock) {toFinish--;}
    }

    public static void main(String[] args)
    {
	for (int j = 1; j < 100; j++) {
	    synchronized (globalLock) {x = 0;}
	    synchronized (globalLock) { toFinish = 0; }
	    while (toFinish < 3) {
		T5 t = new T5(); 
		t.start();
		synchronized (globalLock) {toFinish++;}
	    }
	    
	    while (toFinish > 0) {}
	    System.out.print(".");
	}
	System.out.println("x = " + x);
    }
}
class T6 extends Thread {
    public static int toFinish;
    public static int x;
    public static Object globalLock = new Object();

    public static void zzz(double sec)
    {
	long z = System.currentTimeMillis() + 
	    (long)(1000.0 * sec * Math.random());
	while (System.currentTimeMillis() < z) { }
    }   

    public void run()
    {
	for (int i = 0; i < 100; i++) {
	    synchronized (globalLock) {
		int tmp = x;
		tmp++;
		zzz(0.0001);
		x = tmp;
	    }
	}
	synchronized (globalLock) {toFinish--;}
    }

    public static void main(String[] args)
    {
	for (int j = 1; j < 100; j++) {
	    synchronized (globalLock) {
		x = 0;
		toFinish = 0; 
		while (toFinish < 3) {
		    T6 t = new T6(); 
		    t.start();
		    toFinish++;
		}
	    }
	    while (toFinish > 0) {}
	    System.out.print(".");
	}
	System.out.println("x = " + x);
    }
}
